Package ghidra.trace.database.target

# Record Class ImmutableValueShape

java.lang.Object
java.lang.Record
ghidra.trace.database.target.ImmutableValueShape

All Implemented Interfaces:
  `ValueShape`, `BoundedShape<ValueBox>`

public record ImmutableValueShape(DBTraceObject parent, DBTraceObject child, String entryKey, Lifespan lifespan, int addressSpaceId, long minAddressOffset, long maxAddressOffset) extends Record implements ValueShape

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ImmutableValueShape(DBTraceObject parent, DBTraceObject child, String entryKey, Lifespan lifespan, int addressSpaceId, long minAddressOffset, long maxAddressOffset)`
  Creates an instance of a `ImmutableValueShape` record class.
  `ImmutableValueShape(DBTraceObject parent, Object value, String entryKey, Lifespan lifespan)`
  `ImmutableValueShape(ValueShape shape)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `addressSpaceId()`
  Returns the value of the `addressSpaceId` record component.
  `DBTraceObject`
  `child()`
  Returns the value of the `child` record component.
  `String`
  `description()`
  `String`
  `entryKey()`
  Returns the value of the `entryKey` record component.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `int`
  `getAddressSpaceId()`
  If the value is an address or range, the id of the address space
  `static int`
  `getAddressSpaceId(Object value)`
  `ValueBox`
  `getBounds()`
  `DBTraceObject`
  `getChild()`
  `DBTraceObject`
  `getChildOrNull()`
  `String`
  `getEntryKey()`
  `Lifespan`
  `getLifespan()`
  `long`
  `getMaxAddressOffset()`
  `static long`
  `getMaxAddressOffset(Object value)`
  `long`
  `getMinAddressOffset()`
  `static long`
  `getMinAddressOffset(Object value)`
  `DBTraceObject`
  `getParent()`
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `Lifespan`
  `lifespan()`
  Returns the value of the `lifespan` record component.
  `long`
  `maxAddressOffset()`
  Returns the value of the `maxAddressOffset` record component.
  `long`
  `minAddressOffset()`
  Returns the value of the `minAddressOffset` record component.
  `DBTraceObject`
  `parent()`
  Returns the value of the `parent` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface ghidra.trace.database.target.ValueShape

  `getMaxAddress, getMinAddress, getRange`

- ## Constructor Details

  - ### ImmutableValueShape

    public ImmutableValueShape(DBTraceObject parent, Object value, String entryKey, Lifespan lifespan)

  - ### ImmutableValueShape

    public ImmutableValueShape(ValueShape shape)

  - ### ImmutableValueShape

    public ImmutableValueShape(DBTraceObject parent, DBTraceObject child, String entryKey, Lifespan lifespan, int addressSpaceId, long minAddressOffset, long maxAddressOffset)
    Creates an instance of a `ImmutableValueShape` record class.
    Parameters:
      `parent` - the value for the `parent` record component
      `child` - the value for the `child` record component
      `entryKey` - the value for the `entryKey` record component
      `lifespan` - the value for the `lifespan` record component
      `addressSpaceId` - the value for the `addressSpaceId` record component
      `minAddressOffset` - the value for the `minAddressOffset` record component
      `maxAddressOffset` - the value for the `maxAddressOffset` record component

- ## Method Details

  - ### getAddressSpaceId

    public static int getAddressSpaceId(Object value)

  - ### getMinAddressOffset

    public static long getMinAddressOffset(Object value)

  - ### getMaxAddressOffset

    public static long getMaxAddressOffset(Object value)

  - ### getBounds

    public ValueBox getBounds()
    Specified by:
      `getBounds` in interface `BoundedShape<ValueBox>`

  - ### description

    public String description()
    Specified by:
      `description` in interface `BoundedShape<ValueBox>`

  - ### getParent

    public DBTraceObject getParent()
    Specified by:
      `getParent` in interface `ValueShape`

  - ### getChild

    public DBTraceObject getChild()
    Specified by:
      `getChild` in interface `ValueShape`

  - ### getChildOrNull

    public DBTraceObject getChildOrNull()
    Specified by:
      `getChildOrNull` in interface `ValueShape`

  - ### getEntryKey

    public String getEntryKey()
    Specified by:
      `getEntryKey` in interface `ValueShape`

  - ### getLifespan

    public Lifespan getLifespan()
    Specified by:
      `getLifespan` in interface `ValueShape`

  - ### getAddressSpaceId

    public int getAddressSpaceId()
    Description copied from interface: `ValueShape`
    If the value is an address or range, the id of the address space
    Specified by:
      `getAddressSpaceId` in interface `ValueShape`
    Returns:
      the space id, or -1 for non-address value

  - ### getMinAddressOffset

    public long getMinAddressOffset()
    Specified by:
      `getMinAddressOffset` in interface `ValueShape`

  - ### getMaxAddressOffset

    public long getMaxAddressOffset()
    Specified by:
      `getMaxAddressOffset` in interface `ValueShape`

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. Reference components are compared with `Objects::equals(Object,Object)`; primitive components are compared with '=='.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### parent

    public DBTraceObject parent()
    Returns the value of the `parent` record component.
    Returns:
      the value of the `parent` record component

  - ### child

    public DBTraceObject child()
    Returns the value of the `child` record component.
    Returns:
      the value of the `child` record component

  - ### entryKey

    public String entryKey()
    Returns the value of the `entryKey` record component.
    Returns:
      the value of the `entryKey` record component

  - ### lifespan

    public Lifespan lifespan()
    Returns the value of the `lifespan` record component.
    Returns:
      the value of the `lifespan` record component

  - ### addressSpaceId

    public int addressSpaceId()
    Returns the value of the `addressSpaceId` record component.
    Returns:
      the value of the `addressSpaceId` record component

  - ### minAddressOffset

    public long minAddressOffset()
    Returns the value of the `minAddressOffset` record component.
    Returns:
      the value of the `minAddressOffset` record component

  - ### maxAddressOffset

    public long maxAddressOffset()
    Returns the value of the `maxAddressOffset` record component.
    Returns:
      the value of the `maxAddressOffset` record component